(window["webpackJsonp"] = window["webpackJsonp"] || []).push([["default~pages-home-home-module~pages-swaps-swaps-module"],{

/***/ "3Sgo":
/*!***********************************************************************************************************!*\
  !*** ./node_modules/raw-loader/dist/cjs.js!./src/app/components/turn-swap-popover/turn-swap.popover.html ***!
  \***********************************************************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("<ion-header [translucent]=\"true\">\r\n  <ion-toolbar>\r\n    <ion-title translate>turn_swap.swap_turn</ion-title>\r\n  </ion-toolbar>\r\n</ion-header>\r\n\r\n<ion-content>\r\n  <ion-list>\r\n    <ion-item id=\"direction\">\r\n      <ion-label position=\"floating\" translate>turn_swap.direction</ion-label>\r\n      <ion-select [(ngModel)]=\"swap.direction\" (ionChange)=\"onSwapDirectionChange()\" interface=\"popover\">\r\n        <ion-select-option value=\"USER_TO_COWORKER\" translate>turn_swap.user_to_coworker</ion-select-option>\r\n        <ion-select-option value=\"COWORKER_TO_USER\" translate>turn_swap.coworker_to_user</ion-select-option>\r\n      </ion-select>\r\n    </ion-item>\r\n    <ion-item id=\"coworker\">\r\n      <ion-label position=\"floating\" translate>turn_swap.coworker</ion-label>\r\n      <ion-select [(ngModel)]=\"swap.coworker\" interface=\"popover\">\r\n        <ion-select-option *ngFor=\"let coworker of coworkers\" [value]=\"coworker\">{{ coworker.name }}</ion-select-option>\r\n      </ion-select>\r\n    </ion-item>\r\n    <ion-item id=\"shift-date\">\r\n      <ion-label position=\"floating\" translate>turn_swap.shift_date</ion-label>\r\n      <ion-datetime [(ngModel)]=\"newShift.date\" (ionChange)=\"onDateChange()\" display-format=\"YYYY-MM-DD\" picker-format=\"YYYY-MMMM-DD\"></ion-datetime>\r\n    </ion-item>\r\n    <ion-item id=\"calendar\">\r\n      <ion-label position=\"floating\" translate>turn_swap.calendar</ion-label>\r\n      <ion-select [(ngModel)]=\"newShift.calendar\" (ionChange)=\"onCalendarChange()\" interface=\"popover\">\r\n        <ion-select-option *ngFor=\"let calendar of calendars\" [value]=\"calendar\">{{ calendar.name }}</ion-select-option>\r\n      </ion-select>\r\n    </ion-item>\r\n    <ion-item *ngIf=\"swap.direction === 'USER_TO_COWORKER'\">\r\n      <ion-label position=\"floating\" translate>turn_swap.shift</ion-label>\r\n      <ion-select [(ngModel)]=\"swap.shift\" [disabled]=\"!newShift.calendar\" interface=\"popover\">\r\n        <ion-select-option *ngFor=\"let shift of dayShifts\" [value]=\"shift\">{{ shift.type.name }}</ion-select-option>\r\n      </ion-select>\r\n    </ion-item>\r\n    <ion-item *ngIf=\"swap.direction === 'COWORKER_TO_USER'\">\r\n      <ion-label position=\"floating\" translate>turn_swap.shift_type</ion-label>\r\n      <ion-select [(ngModel)]=\"newShift.type\" [disabled]=\"!newShift.calendar\" interface=\"popover\">\r\n        <ion-select-option *ngFor=\"let shiftType of calendarShiftTypes\" [value]=\"shiftType\">{{ shiftType.name }}</ion-select-option>\r\n      </ion-select>\r\n    </ion-item>\r\n    <ion-item class=\"ion-text-center\" lines=\"none\">\r\n      <ion-label>\r\n        <ion-button (click)=\"cancel()\" color=\"light\" id=\"cancel\" translate>commons.cancel</ion-button>\r\n      </ion-label>\r\n      <ion-label>\r\n        <ion-button (click)=\"save()\" id=\"save\" translate>commons.save</ion-button>\r\n      </ion-label>\r\n    </ion-item>\r\n  </ion-list>\r\n</ion-content>\r\n");

/***/ }),

/***/ "3WFG":
/*!**********************************************!*\
  !*** ./src/app/services/calendar.service.ts ***!
  \**********************************************/
/*! exports provided: CalendarService */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CalendarService", function() { return CalendarService; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! rxjs */ "qCKp");
/* harmony import */ var _database_service__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./database.service */ "ZJFI");




let CalendarService = class CalendarService {
    constructor(database) {
        this.database = database;
    }
    deleteCalendar(calendar) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('DELETE FROM calendars WHERE id = ?', [calendar.id], () => result.complete(), () => result.error("calendars.error.could_not_delete"))));
        return result;
    }
    getCalendars() {
        const calendars = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => {
            db.transaction((tx) => {
                tx.executeSql('SELECT * FROM calendars', [], (_, result) => {
                    calendars.next(this.readCalendars(result.rows));
                });
            });
        });
        return calendars;
    }
    saveCalendar(calendar) {
        var _a;
        calendar.name = (_a = calendar.name) === null || _a === void 0 ? void 0 : _a.trim();
        if (!calendar.name) {
            return Object(rxjs__WEBPACK_IMPORTED_MODULE_2__["throwError"])("calendars.error.empty_name");
        }
        if (!calendar.id) {
            return this.save(calendar);
        }
        return this.update(calendar);
    }
    save(calendar) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('INSERT INTO calendars (name) VALUES (?)', [calendar.name], () => result.complete(), (_, err) => result.error("calendars.error.could_not_save"))));
        return result;
    }
    update(calendar) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('UPDATE calendars SET name = ? WHERE id = ?', [calendar.name, calendar.id], () => result.complete(), () => result.error("calendars.error.could_not_update"))));
        return result;
    }
    readCalendars(rows) {
        const calendars = [];
        for (let i = 0; i < rows.length; i++) {
            calendars.push(rows.item(i));
        }
        return calendars;
    }
};
CalendarService.ctorParameters = () => [
    { type: _database_service__WEBPACK_IMPORTED_MODULE_3__["DatabaseService"] }
];
CalendarService = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_1__["Injectable"])({
        providedIn: 'root'
    })
], CalendarService);



/***/ }),

/***/ "3dOy":
/*!*********************************************************************!*\
  !*** ./src/app/components/turn-swap-popover/turn-swap.popover.scss ***!
  \*********************************************************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony default export */ __webpack_exports__["default"] = ("\n/*# sourceMappingURL=data:application/json;base64,eyJ2ZXJzaW9uIjozLCJzb3VyY2VzIjpbXSwibmFtZXMiOltdLCJtYXBwaW5ncyI6IiIsImZpbGUiOiJ0dXJuLXN3YXAucG9wb3Zlci5zY3NzIn0= */");

/***/ }),

/***/ "GnyV":
/*!*******************************************!*\
  !*** ./src/app/services/shift.service.ts ***!
  \*******************************************/
/*! exports provided: ShiftService */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ShiftService", function() { return ShiftService; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! rxjs */ "qCKp");
/* harmony import */ var _models_coworker__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../models/coworker */ "qGJO");
/* harmony import */ var _models_shift__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../models/shift */ "mg7M");
/* harmony import */ var _models_shift_type__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../models/shift-type */ "KlCm");
/* harmony import */ var _models_swap__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../models/swap */ "IEJJ");
/* harmony import */ var _database_service__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./database.service */ "ZJFI");








let ShiftService = class ShiftService {
    constructor(database) {
        this.database = database;
    }
    deleteShift(shift) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => {
            tx.executeSql('DELETE FROM swaps WHERE shift_id = ?', [shift.id], null, null);
            tx.executeSql('DELETE FROM shifts WHERE id = ?', [shift.id], null, null);
        }).then(() => result.complete()).catch(() => result.error("shifts.error.could_not_delete")));
        return result;
    }
    findShifts(from, to) {
        const shifts = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('SELECT * FROM shifts sh LEFT JOIN swaps sw ON sw.shift_id = sh.id WHERE sh.date >= ? AND sh.date <= ?', [from, to], (tx, shiftResults) => tx.executeSql('SELECT id, name, initials, from_hour as fromHour, to_hour as toHour, hours, price, color FROM shift_types', [], (_, shiftTypesResults) => shifts.next(this.readShifts(shiftResults, shiftTypesResults)), (_, err) => shifts.error(err)), (_, err) => shifts.error(err))));
        return shifts;
    }
    findAllShiftsByCalendarAndDate(calendar, date) {
        const shifts = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('SELECT * FROM shifts sh LEFT JOIN swaps sw ON sw.shift_id = sh.id WHERE sh.calendar_id = ? AND sh.date = ?', [calendar.id, date], (tx, shiftResults) => tx.executeSql('SELECT id, name, initials, from_hour as fromHour, to_hour as toHour, hours, price, color FROM shift_types', [], (_, shiftTypeResults) => shifts.next(this.readShifts(shiftResults, shiftTypeResults)), (_, err) => shifts.error(err)), (_, err) => shifts.error(err))));
        return shifts;
    }
    findShiftsByCalendarAndDate(calendar, date) {
        const shifts = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('SELECT * FROM shifts WHERE calendar_id = ? AND date = ? AND ID NOT IN (SELECT shift_id FROM swaps)', [calendar.id, date], (tx, shiftResults) => tx.executeSql('SELECT id, name, initials, from_hour as fromHour, to_hour as toHour, hours, price, color FROM shift_types', [], (_, shiftTypeResults) => shifts.next(this.readShifts(shiftResults, shiftTypeResults)), (_, err) => shifts.error(err)), (_, err) => shifts.error(err))));
        return shifts;
    }
    findAllSwaps() {
        const swaps = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('SELECT * FROM swaps sw LEFT JOIN shifts sh ON sh.id = sw.shift_id', [], (tx, swapResults) => tx.executeSql('SELECT id, name, initials, from_hour as fromHour, to_hour as toHour, hours, price, color FROM shift_types', [], (tx, shiftTypeResults) => tx.executeSql('SELECT * FROM coworkers', [], (_, coworkerResults) => swaps.next(this.readSwaps(swapResults, shiftTypeResults, coworkerResults)), (_, err) => swaps.error(err)), (_, err) => swaps.error(err)), (_, err) => swaps.error(err))));
        return swaps;
    }
    saveShift(shift) {
        if (!shift.date || !shift.calendar.id || !shift.type.id) {
            return Object(rxjs__WEBPACK_IMPORTED_MODULE_2__["throwError"])("shifts.error.could_not_save");
        }
        if (!shift.id) {
            return this.save(shift);
        }
        return this.update(shift);
    }
    readShifts(shiftResults, shiftTypeResults) {
        const calendarsMap = {};
        const shiftTypesMap = {};
        const shifts = [];
        for (let i = 0; i < shiftTypeResults.rows.length; i++) {
            const row = shiftTypeResults.rows.item(i);
            const shiftType = Object.assign(new _models_shift_type__WEBPACK_IMPORTED_MODULE_5__["ShiftType"](), row);
            shiftTypesMap[shiftType.id] = shiftType;
        }
        for (let i = 0; i < shiftResults.rows.length; i++) {
            const row = shiftResults.rows.item(i);
            const shift = Object.assign(new _models_shift__WEBPACK_IMPORTED_MODULE_4__["Shift"](), row);
            let calendar = calendarsMap[row['calendar_id']];
            if (!calendar) {
                calendar = { id: row['calendar_id'] };
                calendarsMap[calendar.id] = calendar;
            }
            shift.calendar = calendar;
            shift.type = shiftTypesMap[row['shift_type_id']];
            if (row['shift_id']) {
                shift.swap = new _models_swap__WEBPACK_IMPORTED_MODULE_6__["Swap"]();
                shift.swap.shift = shift;
                shift.swap.coworker = new _models_coworker__WEBPACK_IMPORTED_MODULE_3__["Coworker"]();
                shift.swap.coworker.id = row['coworker_id'];
                shift.swap.direction = row['direction'];
            }
            shifts.push(shift);
        }
        return shifts;
    }
    readSwaps(swapResults, shiftTypeResults, coworkerResults) {
        const calendarsMap = {};
        const shiftTypesMap = {};
        const coworkersMap = {};
        const swaps = [];
        for (let i = 0; i < shiftTypeResults.rows.length; i++) {
            const row = shiftTypeResults.rows.item(i);
            const shiftType = Object.assign(new _models_shift_type__WEBPACK_IMPORTED_MODULE_5__["ShiftType"](), row);
            shiftTypesMap[shiftType.id] = shiftType;
        }
        for (let i = 0; i < coworkerResults.rows.length; i++) {
            const row = coworkerResults.rows.item(i);
            const coworker = Object.assign(new _models_coworker__WEBPACK_IMPORTED_MODULE_3__["Coworker"](), row);
            coworkersMap[coworker.id] = coworker;
        }
        for (let i = 0; i < swapResults.rows.length; i++) {
            const row = swapResults.rows.item(i);
            const swap = Object.assign(new _models_swap__WEBPACK_IMPORTED_MODULE_6__["Swap"](), row);
            const shift = Object.assign(new _models_shift__WEBPACK_IMPORTED_MODULE_4__["Shift"](), row);
            let calendar = calendarsMap[row['calendar_id']];
            if (!calendar) {
                calendar = { id: row['calendar_id'] };
                calendarsMap[calendar.id] = calendar;
            }
            shift.calendar = calendar;
            shift.type = shiftTypesMap[row['shift_type_id']];
            shift.swap = swap;
            swap.shift = shift;
            swap.coworker = coworkersMap[row['coworker_id']];
            swaps.push(swap);
        }
        return swaps;
    }
    save(shift) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('INSERT INTO shifts (date, calendar_id, shift_type_id) VALUES (?, ?, ?)', [shift.date, shift.calendar.id, shift.type.id], (tx, insert) => {
            if (shift.swap != null) {
                tx.executeSql('INSERT INTO swaps (shift_id, coworker_id, direction) VALUES (?, ?, ?)', [insert.insertId, shift.swap.coworker.id, shift.swap.direction]);
            }
        })).then(() => result.complete()).catch(() => result.error("shifts.error.could_not_save")));
        return result;
    }
    update(shift) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('DELETE FROM swaps WHERE shift_id = ?', [shift.id], (tx) => {
            if (shift.swap != null) {
                tx.executeSql('INSERT INTO swaps (shift_id, coworker_id, direction) VALUES (?, ?, ?)', [shift.id, shift.swap.coworker.id, shift.swap.direction]);
            }
        })).then(() => result.complete()).catch(() => result.error("shifts.error.could_not_save")));
        return result;
    }
};
ShiftService.ctorParameters = () => [
    { type: _database_service__WEBPACK_IMPORTED_MODULE_7__["DatabaseService"] }
];
ShiftService = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_1__["Injectable"])({
        providedIn: 'root'
    })
], ShiftService);



/***/ }),

/***/ "IEJJ":
/*!********************************!*\
  !*** ./src/app/models/swap.ts ***!
  \********************************/
/*! exports provided: Swap */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Swap", function() { return Swap; });
class Swap {
    isFromCoworker() {
        return this.direction.toString() === 'COWORKER_TO_USER';
    }
    isToCoworker() {
        return this.direction.toString() === 'USER_TO_COWORKER';
    }
    getOwingHours() {
        return this.isToCoworker() ? this.shift.type.hours : -this.shift.type.hours;
    }
}


/***/ }),

/***/ "KlCm":
/*!**************************************!*\
  !*** ./src/app/models/shift-type.ts ***!
  \**************************************/
/*! exports provided: ShiftType */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ShiftType", function() { return ShiftType; });
class ShiftType {
    constructor() {
        this.fromHour = "12:00";
        this.toHour = "12:00";
        this.calendars = [];
        this.reminders = [];
    }
    getContrastColor() {
        return (this.getRelativeLuminance() > 0.179) ? "#000000" : "#FFFFFF";
    }
    isEnabledForCalendar(calendar) {
        return this.calendars.some((it) => it.id === calendar.id);
    }
    getRelativeLuminance() {
        const r = this.getRelativeLuminanceComponent(this.color.substring(1, 3));
        const g = this.getRelativeLuminanceComponent(this.color.substring(3, 5));
        const b = this.getRelativeLuminanceComponent(this.color.substring(5));
        return 0.2126 * r + 0.7152 * g + 0.0722 * b;
    }
    getRelativeLuminanceComponent(hex) {
        const c = parseInt(hex, 16) / 255.0;
        if (c <= 0.03928) {
            return c / 12.92;
        }
        return Math.pow((c + 0.055) / 1.055, 2.4);
    }
}


/***/ }),

/***/ "MBEz":
/*!**********************************************!*\
  !*** ./src/app/services/coworker.service.ts ***!
  \**********************************************/
/*! exports provided: CoworkerService */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "CoworkerService", function() { return CoworkerService; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! rxjs */ "qCKp");
/* harmony import */ var _models_coworker__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../models/coworker */ "qGJO");
/* harmony import */ var _database_service__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./database.service */ "ZJFI");





let CoworkerService = class CoworkerService {
    constructor(database) {
        this.database = database;
    }
    deleteCoworker(coworker) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => {
            tx.executeSql('DELETE FROM coworkers WHERE id = ?', [coworker.id], null, null);
            tx.executeSql('DELETE FROM calendars_coworkers WHERE coworker_id = ?', [coworker.id], null, null);
        }).then(() => result.complete()).catch(() => result.error("coworkers.error.could_not_delete")));
        return result;
    }
    getCoworkers() {
        const coworkers = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('SELECT * FROM coworkers', [], (tx, coworkersResults) => tx.executeSql('SELECT * FROM calendars_coworkers', [], (_, calendarsCoworkersResults) => coworkers.next(this.readCoworkers(coworkersResults, calendarsCoworkersResults)), (_, err) => coworkers.error(err)), (_, err) => coworkers.error(err))));
        return coworkers;
    }
    saveCoworker(coworker) {
        var _a;
        coworker.name = (_a = coworker.name) === null || _a === void 0 ? void 0 : _a.trim();
        if (!coworker.name) {
            return Object(rxjs__WEBPACK_IMPORTED_MODULE_2__["throwError"])("coworkers.error.empty_name");
        }
        if (!coworker.id) {
            return this.save(coworker);
        }
        return this.update(coworker);
    }
    readCoworkers(coworkersResults, calendarsCoworkersResults) {
        const coworkersMap = {};
        const calendarsMap = {};
        for (let i = 0; i < coworkersResults.rows.length; i++) {
            const row = coworkersResults.rows.item(i);
            const coworker = Object.assign(new _models_coworker__WEBPACK_IMPORTED_MODULE_3__["Coworker"](), row);
            coworkersMap[coworker.id] = coworker;
        }
        for (let i = 0; i < calendarsCoworkersResults.rows.length; i++) {
            const row = calendarsCoworkersResults.rows.item(i);
            const coworker = coworkersMap[row['coworker_id']];
            let calendar = calendarsMap[row['calendar_id']];
            if (!calendar) {
                calendar = { id: row['calendar_id'] };
                calendarsMap[calendar.id] = calendar;
            }
            coworker.calendars.push(calendar);
        }
        return Object.values(coworkersMap);
    }
    save(coworker) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('INSERT INTO coworkers (name) VALUES (?)', [coworker.name], (tx, insert) => coworker.calendars.forEach(calendar => {
            tx.executeSql('INSERT INTO calendars_coworkers (calendar_id, coworker_id) VALUES (?, ?)', [calendar.id, insert.insertId], null, () => result.error("coworkers.error.could_not_save"));
        }), () => result.error("coworkers.error.could_not_save"))).then(() => result.complete()).catch(() => result.error("coworkers.error.could_not_save")));
        return result;
    }
    update(coworker) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => {
            tx.executeSql('UPDATE coworkers SET name = ? WHERE id = ?', [coworker.name, coworker.id], null, () => result.error("coworkers.error.could_not_update"));
            tx.executeSql('DELETE FROM calendars_coworkers WHERE coworker_id = ?', [coworker.id], null, () => result.error("coworkers.error.could_not_save"));
            coworker.calendars.forEach(calendar => {
                tx.executeSql('INSERT INTO calendars_coworkers (calendar_id, coworker_id) VALUES (?, ?)', [calendar.id, coworker.id], null, () => result.error("coworkers.error.could_not_save"));
            });
        }).then(() => result.complete()).catch(() => result.error("coworkers.error.could_not_save")));
        return result;
    }
};
CoworkerService.ctorParameters = () => [
    { type: _database_service__WEBPACK_IMPORTED_MODULE_4__["DatabaseService"] }
];
CoworkerService = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_1__["Injectable"])({
        providedIn: 'root'
    })
], CoworkerService);



/***/ }),

/***/ "Nd7p":
/*!*******************************************************************!*\
  !*** ./src/app/components/turn-swap-popover/turn-swap.popover.ts ***!
  \*******************************************************************/
/*! exports provided: TurnSwapPopover */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "TurnSwapPopover", function() { return TurnSwapPopover; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _raw_loader_turn_swap_popover_html__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! raw-loader!./turn-swap.popover.html */ "3Sgo");
/* harmony import */ var _turn_swap_popover_scss__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./turn-swap.popover.scss */ "3dOy");
/* harmony import */ var _angular_common__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! @angular/common */ "ofXK");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var _ionic_angular__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ionic/angular */ "TEn/");
/* harmony import */ var src_app_models_shift__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! src/app/models/shift */ "mg7M");
/* harmony import */ var src_app_services_calendar_service__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! src/app/services/calendar.service */ "3WFG");
/* harmony import */ var src_app_services_shift_service__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! src/app/services/shift.service */ "GnyV");
/* harmony import */ var src_app_services_shift_type_service__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! src/app/services/shift-type.service */ "s1Pa");
/* harmony import */ var src_app_models_swap__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! src/app/models/swap */ "IEJJ");
/* harmony import */ var src_app_services_coworker_service__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! src/app/services/coworker.service */ "MBEz");












let TurnSwapPopover = class TurnSwapPopover {
    constructor(popover, app, calendarService, coworkerService, shiftService, shiftTypeService, datePipe) {
        this.popover = popover;
        this.app = app;
        this.calendarService = calendarService;
        this.coworkerService = coworkerService;
        this.shiftService = shiftService;
        this.shiftTypeService = shiftTypeService;
        this.datePipe = datePipe;
        this.newShift = new src_app_models_shift__WEBPACK_IMPORTED_MODULE_6__["Shift"]();
        this.calendars = [];
        this.calendarShiftTypes = [];
        this.coworkers = [];
        this.dayShifts = [];
        this.swap = new src_app_models_swap__WEBPACK_IMPORTED_MODULE_10__["Swap"]();
        this.shiftTypes = [];
        this.newShift.date = this.datePipe.transform(new Date(), 'yyyy-MM-dd');
        this.loadCalendars();
        this.loadCoworkers();
        this.loadShiftTypes();
    }
    ngOnInit() { }
    cancel() {
        this.popover.dismiss(null, "cancel");
    }
    onCalendarChange() {
        this.calendarShiftTypes = this.shiftTypes.filter((it) => it.isEnabledForCalendar(this.newShift.calendar));
        if (this.newShift.type != null && !this.newShift.type.isEnabledForCalendar(this.newShift.calendar)) {
            this.newShift.type = null;
        }
        this.loadDayShifts();
    }
    onDateChange() {
        this.loadDayShifts();
    }
    onSwapDirectionChange() {
        this.loadDayShifts();
    }
    save() {
        switch (this.swap.direction.toString()) {
            case 'COWORKER_TO_USER':
                this.newShift.date = this.datePipe.transform(this.newShift.date, 'yyyy-MM-dd');
                this.newShift.swap = this.swap;
                this.swap.shift = this.newShift;
                this.shiftService.saveShift(this.newShift).subscribe({
                    complete: () => this.popover.dismiss(null, "save")
                });
                break;
            case 'USER_TO_COWORKER':
                this.swap.shift.swap = this.swap;
                this.shiftService.saveShift(this.swap.shift).subscribe({
                    complete: () => this.popover.dismiss(null, "save")
                });
                break;
        }
    }
    loadCalendars() {
        this.calendarService.getCalendars().subscribe({
            next: calendars => {
                this.calendars = calendars;
                this.app.tick();
            }
        });
    }
    loadCoworkers() {
        this.coworkerService.getCoworkers().subscribe({
            next: coworkers => {
                this.coworkers = coworkers;
                this.app.tick();
            }
        });
    }
    loadDayShifts() {
        if (this.newShift.calendar != null && this.newShift.date != null) {
            const date = this.datePipe.transform(this.newShift.date, 'yyyy-MM-dd');
            this.shiftService.findShiftsByCalendarAndDate(this.newShift.calendar, date).subscribe({
                next: shifts => {
                    this.dayShifts = shifts;
                    this.app.tick();
                }
            });
        }
    }
    loadShiftTypes() {
        this.shiftTypeService.getShiftTypes().subscribe({
            next: shiftTypes => {
                this.shiftTypes = shiftTypes;
                this.app.tick();
            }
        });
    }
};
TurnSwapPopover.ctorParameters = () => [
    { type: _ionic_angular__WEBPACK_IMPORTED_MODULE_5__["PopoverController"] },
    { type: _angular_core__WEBPACK_IMPORTED_MODULE_4__["ApplicationRef"] },
    { type: src_app_services_calendar_service__WEBPACK_IMPORTED_MODULE_7__["CalendarService"] },
    { type: src_app_services_coworker_service__WEBPACK_IMPORTED_MODULE_11__["CoworkerService"] },
    { type: src_app_services_shift_service__WEBPACK_IMPORTED_MODULE_8__["ShiftService"] },
    { type: src_app_services_shift_type_service__WEBPACK_IMPORTED_MODULE_9__["ShiftTypeService"] },
    { type: _angular_common__WEBPACK_IMPORTED_MODULE_3__["DatePipe"] }
];
TurnSwapPopover = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_4__["Component"])({
        selector: 'app-turn-swap-popover',
        template: _raw_loader_turn_swap_popover_html__WEBPACK_IMPORTED_MODULE_1__["default"],
        styles: [_turn_swap_popover_scss__WEBPACK_IMPORTED_MODULE_2__["default"]]
    })
], TurnSwapPopover);



/***/ }),

/***/ "mg7M":
/*!*********************************!*\
  !*** ./src/app/models/shift.ts ***!
  \*********************************/
/*! exports provided: Shift */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Shift", function() { return Shift; });
class Shift {
    constructor() {
        this.swap = null;
    }
    getColor() {
        return this.type.color;
    }
    getContrastColor() {
        return this.type.getContrastColor();
    }
    hasSwap() {
        return this.swap != null;
    }
    isSwappedToCoworker() {
        return this.hasSwap() && this.swap.isToCoworker();
    }
}


/***/ }),

/***/ "qGJO":
/*!************************************!*\
  !*** ./src/app/models/coworker.ts ***!
  \************************************/
/*! exports provided: Coworker */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "Coworker", function() { return Coworker; });
class Coworker {
    constructor() {
        this.calendars = [];
    }
}


/***/ }),

/***/ "s1Pa":
/*!************************************************!*\
  !*** ./src/app/services/shift-type.service.ts ***!
  \************************************************/
/*! exports provided: ShiftTypeService */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "ShiftTypeService", function() { return ShiftTypeService; });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "mrSG");
/* harmony import */ var _angular_core__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @angular/core */ "fXoL");
/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! rxjs */ "qCKp");
/* harmony import */ var _models_shift_type__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../models/shift-type */ "KlCm");
/* harmony import */ var _database_service__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./database.service */ "ZJFI");





let ShiftTypeService = class ShiftTypeService {
    constructor(database) {
        this.database = database;
    }
    deleteShiftType(shiftType) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => {
            tx.executeSql('DELETE FROM shift_types WHERE id = ?', [shiftType.id], null, null);
            tx.executeSql('DELETE FROM calendars_shift_types WHERE shift_type_id = ?', [shiftType.id], null, null);
        }).then(() => result.complete()).catch(() => result.error("shift_types.error.could_not_delete")));
        return result;
    }
    getShiftTypes() {
        const shiftTypes = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('SELECT id, name, initials, from_hour as fromHour, to_hour as toHour, hours, price, color FROM shift_types', [], (tx, shiftTypesResults) => tx.executeSql('SELECT * FROM calendars_shift_types', [], (_, calendarsShiftTypesResults) => shiftTypes.next(this.readShiftTypes(shiftTypesResults, calendarsShiftTypesResults)), (_, err) => shiftTypes.error(err)), (_, err) => shiftTypes.error(err))));
        return shiftTypes;
    }
    saveShiftType(shiftType) {
        var _a;
        shiftType.name = (_a = shiftType.name) === null || _a === void 0 ? void 0 : _a.trim();
        if (!shiftType.name) {
            return Object(rxjs__WEBPACK_IMPORTED_MODULE_2__["throwError"])("shift_types.error.empty_name");
        }
        if (!shiftType.id) {
            return this.save(shiftType);
        }
        return this.update(shiftType);
    }
    readShiftTypes(shiftTypesResults, calendarsShiftTypesResults) {
        const shiftTypesMap = {};
        const calendarsMap = {};
        for (let i = 0; i < shiftTypesResults.rows.length; i++) {
            const row = shiftTypesResults.rows.item(i);
            const shiftType = Object.assign(new _models_shift_type__WEBPACK_IMPORTED_MODULE_3__["ShiftType"](), row);
            shiftTypesMap[shiftType.id] = shiftType;
        }
        for (let i = 0; i < calendarsShiftTypesResults.rows.length; i++) {
            const row = calendarsShiftTypesResults.rows.item(i);
            const shiftType = shiftTypesMap[row['shift_type_id']];
            let calendar = calendarsMap[row['calendar_id']];
            if (!calendar) {
                calendar = { id: row['calendar_id'] };
                calendarsMap[calendar.id] = calendar;
            }
            shiftType.calendars.push(calendar);
        }
        return Object.values(shiftTypesMap);
    }
    save(shiftType) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => tx.executeSql('INSERT INTO shift_types (name, initials, from_hour, to_hour, hours, price, color) VALUES (?, ?, ?, ?, ?, ?, ?)', [shiftType.name, shiftType.initials, shiftType.fromHour, shiftType.toHour, shiftType.hours, shiftType.price, shiftType.color], (tx, insert) => shiftType.calendars.forEach(calendar => {
            tx.executeSql('INSERT INTO calendars_shift_types (calendar_id, shift_type_id) VALUES (?, ?)', [calendar.id, insert.insertId], null, () => result.error("shift_types.error.could_not_save"));
        }), () => result.error("shift_types.error.could_not_save"))).then(() => result.complete()).catch(() => result.error("shift_types.error.could_not_save")));
        return result;
    }
    update(shiftType) {
        const result = new rxjs__WEBPACK_IMPORTED_MODULE_2__["Subject"]();
        this.database.getDatabase().subscribe((db) => db.transaction((tx) => {
            tx.executeSql('UPDATE shift_types SET name = ?, initials = ?, from_hour = ?, to_hour = ?, hours = ?, price = ?, color = ? WHERE id = ?', [shiftType.name, shiftType.initials, shiftType.fromHour, shiftType.toHour, shiftType.hours, shiftType.price, shiftType.color, shiftType.id], null, () => result.error("shift_types.error.could_not_update"));
            tx.executeSql('DELETE FROM calendars_shift_types WHERE shift_type_id = ?', [shiftType.id], null, () => result.error("shift_types.error.could_not_save"));
            shiftType.calendars.forEach(calendar => {
                tx.executeSql('INSERT INTO calendars_shift_types (calendar_id, shift_type_id) VALUES (?, ?)', [calendar.id, shiftType.id], null, () => result.error("shift_types.error.could_not_save"));
            });
        }).then(() => result.complete()).catch(() => result.error("shift_types.error.could_not_save")));
        return result;
    }
};
ShiftTypeService.ctorParameters = () => [
    { type: _database_service__WEBPACK_IMPORTED_MODULE_4__["DatabaseService"] }
];
ShiftTypeService = Object(tslib__WEBPACK_IMPORTED_MODULE_0__["__decorate"])([
    Object(_angular_core__WEBPACK_IMPORTED_MODULE_1__["Injectable"])({
        providedIn: 'root'
    })
], ShiftTypeService);



/***/ })

}]);
//# sourceMappingURL=default~pages-home-home-module~pages-swaps-swaps-module.js.map